<?php

	include_once( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
	include_once( PLOG_CLASS_PATH."class/view/admin/adminplugintemplatedview.class.php" );
	include_once( PLOG_CLASS_PATH."plugins/apod/class/view/pluginapodconfigview.class.php" );	
		
	/**
	 * updates the plugin configuration
	 */
	class PluginapodUpdateConfigAction extends AdminAction
	{
		var $_pluginEnabled;

		
		function PluginapodUpdateConfigAction( $actionInfo, $request )
		{
			$this->AdminAction( $actionInfo, $request );
		}
		
		function validate()
		{

			$this->_pluginEnabled = $this->_request->getValue( "pluginEnabled" );
            $this->_pluginEnabled = ($this->_pluginEnabled != "" );


			$this->_width = $this->_request->getValue( "width" );
            if( $this->_width == "" ) {
                $this->_view = new PluginapodConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("apod_error_width"));
                $this->setCommonData();

                return false;                
            }

			$this->_height = $this->_request->getValue( "height" );
            if( $this->_height == "" ) {
                $this->_view = new PluginapodConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("apod_error_height"));
                $this->setCommonData();

                return false;                
            }			
			
			return true;
		}
		        
		function perform()
		{
            // // update the plugin configurations to blog setting
			$blogSettings = $this->_blogInfo->getSettings();
            $blogSettings->setValue( "plugin_apod_enabled", $this->_pluginEnabled );

            $blogSettings->setValue( "plugin_apod_width", $this->_width );
            $blogSettings->setValue( "plugin_apod_height", $this->_height );

           
            $this->_blogInfo->setSettings( $blogSettings ); 
		
			// save the blogs settings
			$blogs = new Blogs();
            if( !$blogs->updateBlog( $this->_blogInfo )) {
                $this->_view = new PluginapodConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("error_updating_settings"));
                $this->setCommonData();

                return false;
            }
			
			// if everything went ok...
            $this->_blogInfo->setSettings( $blogSettings );
            $this->_session->setValue( "blogInfo", $this->_blogInfo );
            $this->saveSession();

			$this->_view = new PluginapodConfigView( $this->_blogInfo );
			$this->_view->setSuccessMessage( $this->_locale->tr("apod_settings_saved_ok"));
			$this->setCommonData();
			
			// clear the cache
			CacheControl::resetBlogCache( $this->_blogInfo->getId());				
            
            return true;		
		}
	}
?>
